// JavaScript Document//'closure" pour éviter de poluer l'object global window
// On attend que PhoneGap soit chargé
function onBodyLoad() {		
onDeviceReady();
}

// Quand PhoneGap est chargé, on lance l'application
function onDeviceReady() {

	// point d'entrée
	$('#take-picture-btn').bind('click', function(event) {

		// prise de photo
		// ATTENTION AUX DIFFERENTES AUTORISATIONS sur les plate-formes
		// voir doc. CAMERA

		// onSuccess : photo réussie
		// onFail : photo ratée
		// options :
		/*****************************************

		quality : 75, 			> compression (0 à 100)

		--- Camera.DestinationType
			DATA_URL : 0, 		> Return image as base64 encoded string
        	FILE_URI : 1 		> Return image file URI
		destinationType : Camera.DestinationType.DATA_URL, 

		--- Camera.SourceType :
			PHOTOLIBRARY : 0,	> Lib de photos
	    	CAMERA : 1,			> Appareil photo
	    	SAVEDPHOTOALBUM : 2	> 
		sourceType : Camera.PictureSourceType.CAMERA,

		--- permet une édition simple avant la sélection
		allowEdit : true,

		--- Camera.EncodingType
			JPEG : 0,            > Return JPEG encoded image
        	PNG : 1              > Return PNG encoded image
		encodingType: Camera.EncodingType.JPEG,

		--- Taille désirée de l'image
			Le ratio est conservé, 
			il faut spécifier largeur **ET** hauteur
		targetWidth: 100,
		targetHeight: 100,

		--- Camera.MediaType
	    	PICTURE: 0,          > allow selection of still pictures only. DEFAULT. Will return format specified via DestinationType
	    	VIDEO: 1,            > allow selection of video only, WILL ALWAYS RETURN FILE_URI
	    	ALLMEDIA : 2         > allow selection from all media types
	    mediaType: Camera.PICTURE,

	    --- correctOrientation (Boolean)
	    	Rotate the image to correct for the orientation of the device during capture. (Boolean)
	   	correctOrientation: false,

		--- saveToPhotoAlbum (Boolean)
			Save the image to the photo album on the device after capture. (Boolean)
		saveToPhotoAlbum: false,

		--- popoverOptions
			iOS only options to specify popover location in iPad. Defined in CameraPopoverOptions
		popoverOptions: CameraPopoverOptions;


		*/ 
		navigator.camera.getPicture(onSuccess, 
									onFail, 	
									{ 	
										quality: 50,
	    								destinationType: Camera.DestinationType.DATA_URL
	 								}); 
	});

	$('#library-btn').bind('click', function(event) {
		navigator.camera.getPicture(onSuccess, 
									onFail, 	
									{ 	
										quality: 50,
										sourceType : Camera.PictureSourceType.PHOTOLIBRARY,
	    								destinationType: Camera.DestinationType.DATA_URL
	 								});
	});
	
	
}



function onSuccess(imageData) {

    var $image = $('<img src="data:image/jpeg;base64,' + imageData + '" id="monImage" class="auto-size">');
    $('#images').append($image);
}

function onFail(message) {
    alert('Erreur: ' + message);
}

function log(message) {
    
    if (!this.output) {
        
        this.output = document.getElementById('log');
        $(this.output).bind('swipe', function(e) {
            $(this).empty();
        })
    }
    
    this.output.innerHTML += message + '<br>';

}


(function($){

//config par défaut voir fichier evenement-mobile-init.html	
$(document).bind('mobileinit', function(){
});

//injection du footer dans nos pages 




$(document).bind('pagebeforecreate', function(e){
  var viewPortHeight = $(window).height();
    var headerHeight = $('div[data-role="header"]').height();
    var footerHeight = $('div[data-role="footer"]').height();
    var contentHeight = viewPortHeight - headerHeight - footerHeight;

    // Set all pages with class="page-content" to be at least contentHeight
    $('div[class="page-content"]').css({'min-height': contentHeight + 'px'});	

	//on récupère la page et on l'encapsule dans un jq object
	var $page = $(e.target);
	
	//on test si on est bien sur une page 
	if($page.attr('data-role')!='page'){
		return;
	}
	
	// on récupère l'id : 
	var idPage = $page.attr('id');

if(idPage != 'home'){
	//On cible le header
	var $header = $page.find('div[data-role=header]');
	// si il y a un footer et qu'il est vide 
	if($header && $header.find('li').length==0){
		//on injecte : 
		injecteNaveBarreHeader(idPage, $header);	
	}
	
	//On cible le footer 
	var $footer = $page.find('div[data-role=footer]');
	// si il y a un footer et qu'il est vide 
	if($footer && $footer.find('li').length==0){
		//on injecte : 
		injecteNaveBarre(idPage, $footer);	
	}	
}

if(idPage=='interactivmap'){	
$('#map_canvas').gmap('loadKML', 'etape1', 'http://www.lepuyconques.com/mobile/fichiers/Etape1m-LePuy-en-VelaySaint-PrivatdAllier(2).kml');
$('#map_canvas').gmap('get','map').setOptions({'zoom':17});
$('#map_canvas').css({'min-height': contentHeight + 'px'});	

}


$('#detail_prestataire').live('pagebeforeshow', function(e){
	var id_presta_url = getParamValue('id_poi');
if(id_presta_url!=''){
	ClickDetailPrestataire(id_presta_url);
	
}

});


});


function injecteNaveBarre(idPage, $footer){
var NavBarreHTML = '<div data-role="navbar" class="fm-navbar" data-theme="d" data-iconpos="left">'
        			+	'<ul>'
					+		'<li><a  href="#aide" rel="aide" data-icon="fm-aide" data-shadow="false"><span langue="fr">Aide<br>&nbsp;</span></a></li>'
               		+		'<li><a  href="#gr65" rel="gr65" data-icon="fm-gr65" data-shadow="false"><span langue="fr">GR 65</span><br><span class="legend" langue="fr">Via Podiensis</span></a></li>'
            		+		'<li><a  href="#accessibilite" rel="accessibilite"><img src="images/picto_handicap.jpg" alt="Accessibilite Handicap" title="Accessibilite Handicap" ></a></li>'
             		+	'</ul>'
					+ '</div>';
	//on transforme le marqueru en objet jquerry
	var $navBarr = $(NavBarreHTML);
	
	//on virre le icone shadow utilisé par défaut
	$navBarr
		.find('ul li a')
		.attr('data-iconshadow', false);
	
	//ajout des classes sur le bouton de la rubrique sélectionnée
	$navBarr
	.find('ul li a[rel='+idPage+']')
	.addClass('ui-btn-active ui-state-persist');
	
	//ajout des attributs sur le footer : 
	$footer.attr({
	'data-tap-toggle':"true",
	'data-id':"mon-footer"
	});
	//on injecte la navBarre dans le footer : 
	$footer.html($navBarr);
}


function injecteNaveBarreHeader(idPage, $header){
	
if(idPage=='interactivmap'){	
var NavBarreHTML = '<div data-role="navbar" class="fm-navbar-header" data-theme="d" data-iconpos="left">'
        			+	'<ul>'
               		+		'<li><a  href="#home" rel="gr65" data-icon="fm-back" data-shadow="false"><span class="green">Le Puy-en-Velay <br>St-Privat d\'Allier</span></a></li>'
               		+		'<li><a href="#control" data-rel="popup" data-role="button" data-transition="slidedown" data-inline="true" rel="decouvrir" data-icon="fm-direction" data-shadow="false" data-iconpos="top" ><span lang="fr">A découvrir<br>&nbsp;</span></a></li>'
					+ '</ul>'
					+ '</div>';
}else{
var NavBarreHTML = '<div data-role="navbar" class="fm-navbar-header" data-theme="d" data-iconpos="left">'
        			+	'<ul>'
               		+		'<li><a  href="#home" rel="gr65" data-icon="fm-back" data-shadow="false" ><span class="green">Le Puy-en-Velay <br>St-Privat d\'Allier</span></a></li>'
               		+		'<li><a href="#interactivmap" data-role="button" data-inline="true" rel="decouvrir" data-icon="fm-direction" data-shadow="false" data-iconpos="top" ><span lang="fr">Carte<br> interactive</span></a></li>'
					//+		'<li><a  href="#carnet" rel="coupcoeur" data-icon="fm-heart" data-shadow="false" data-iconpos="top" >Carnet<br>de Voyage</a></li>'
             		+	'</ul>'
					+ '</div>';	
}
	//on transforme le marqueru en objet jquerry
	var $navBarr = $(NavBarreHTML);
	
	//on virre le icone shadow utilisé par défaut
	$navBarr
		.find('ul li a')
		.attr('data-iconshadow', false);
	
	//ajout des classes sur le bouton de la rubrique sélectionnée
	$navBarr
	.find('ul li a[rel='+idPage+']')
	.addClass('ui-btn-active ui-state-persist');
	
	//ajout des attributs sur le footer : 
	$header.attr({
	'data-tap-toggle':"true",
	'data-id':"mon-footer"
	});
	//on injecte la navBarre dans le footer : 
	$header.html($navBarr);
}

function resizeHome(){
	heightfull = $('body').height();
	heightbottom = $('#home div[data-role=footer]').height();
	heighthead = $('#home div[data-role=header]').height();
	var heightcontent = (heightfull-heightbottom-heighthead)-120;
	$('#home div[data-role=content]').height(heightcontent);
}


$(document).bind('pageshow', function(e){
		//on récupère la page et on l'encapsule dans un jq object
	var $page = $(e.target);
	var idPage = $page.attr('id');
	
	//on test si on est bien sur une page 
	if($page.attr('data-role')!='page'){
		return;
	}

if(idPage=='home'){
resizeHome();	
}
	
	// on récupère l'id : 

if(idPage=='interactivmap'){
	$('#map_canvas').gmap('refresh');
$('#map_canvas').gmap({'center': new google.maps.LatLng(45.04556,3.883996), 'zoom':10});

var PointDepart = new google.maps.LatLng(45.045616,3.884307);	
if(PointDepart){
$('#map_canvas').gmap('addMarker', { 'id': 'point_depart', 'title':'Point de départ de l\'étape', 'position':  PointDepart, 'bounds': false, 'optimized':false, 'icon' : 'images/picto_depart.png'});
}
var PointArrivee = new google.maps.LatLng(44.989813,3.679206);	
if(PointArrivee){
$('#map_canvas').gmap('addMarker', { 'id': 'point_arrivee', 'title':'Arrivée de l\'étape', 'position':  PointArrivee, 'bounds': false, 'optimized':false, 'icon' : 'images/picto_arrivee.png'});
}


	$('#map_canvas').gmap('watchPosition', function(position, status) {
		console.log(status);
		if ( status === 'OK' ) {
			var clientPosition = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
			var userMarker = $('#map_canvas').gmap('get', 'markers > user' );
	
			
            if (!userMarker) {

                         $('#map_canvas').gmap('addMarker', { 'id': 'user',  'position':  clientPosition, 'bounds': false, 'optimized':false, 'icon' : 'images/youarehere.gif'});
						$('#map_canvas').gmap('get','map').setOptions({'center':clientPosition, 'zoom':17});
		
                        } else {
                            userMarker.setPosition(clientPosition);
                        }
        }

});
$('#maposition').click(function(e){
$('#map_canvas').gmap('get','map').setOptions({'center':clientPosition, 'zoom':17});
});



$('#control a').click(ClickAffichage);

}
if(idPage=='detail_prestataire'){

}
});

var openedInfoWindow = null;

	
function ClickAffichage(event){
	event.preventDefault();
	
	var idType = $(this).attr('rel');
	var Theme = $(this).parent().parent().parent().attr('data-theme');
	console.log(Theme);
	if(!Theme){
		Theme='b';
	}



	if(Theme=='b'){
		var trouve = 0;
		 $('#map_canvas').gmap('find', 'markers', { }, function(marker) {
         if(marker.title == idType){marker.setVisible(true);
		 $("#interactivmap #control li[rel="+idType+"]").attr('data-theme', 'e');
		$("#interactivmap #control li[rel="+idType+"] img").attr('src', 'images/picto_'+idType+'_on.png');
		$("#interactivmap #control" ).popup( "close" );		
		 trouve=1;
		 }
});
		
		if(trouve==0){
		$.ajax({
		url:'http://www.lepuyconques.com/mobile/get_content.php?action=getListPrestatairebyType&idType='+idType, 
		dataType:'json', 
		success: getListPrestataireSuccess,
		error: onAjaxError
		});
		}
		 
	}else{
		//$('#map_canvas').get('markers' > 'm_1').setMap(null);
 $('#map_canvas').gmap('find', 'markers', { }, function(marker) {
                    if(marker.title == idType){marker.setVisible(false);}
}); 		
$("#interactivmap #control li[rel="+idType+"]").attr('data-theme', 'b').removeClass('ui-btn-hover-e ui-btn-up-e');
$("#interactivmap #control li[rel="+idType+"] img").attr('src', 'images/picto_'+idType+'.png');
$("#interactivmap #control" ).popup( "close" );	
if (openedInfoWindow != null) openedInfoWindow.close();
		
	}
}



function getListPrestataireSuccess(data){
		PrestataireJSON=data;
		//var nom_presta = array;
for(var i=0 ; i<PrestataireJSON.result.length; i++){
$("#interactivmap #control li[rel="+PrestataireJSON.result[i].id_type_prestataire+"]").attr('data-theme', 'e');
$("#interactivmap #control li[rel="+PrestataireJSON.result[i].id_type_prestataire+"] img").attr('src', 'images/picto_'+PrestataireJSON.result[i].id_type_prestataire+'_on.png');
$("#interactivmap #control" ).popup( "close" );			
				var id = PrestataireJSON.result[i].id_prestataire;
				
				var prestataireMarker = $('#map_canvas').gmap('get', 'markers > presta_'+id);
if (!prestataireMarker){
				var prestaPosition = new google.maps.LatLng(PrestataireJSON.result[i].latitude, PrestataireJSON.result[i].longitude);	
if(prestaPosition){
$('#map_canvas').gmap('addMarker', { 'id': 'presta_'+id, 'id_alone':id, 'title':PrestataireJSON.result[i].id_type_prestataire, 'position':  prestaPosition, 'bounds': false, 'optimized':false, 'icon' : 'images/'+PrestataireJSON.result[i].picto, 'content': PrestataireJSON.result[i].nom, 'sous_type':PrestataireJSON.result[i].nom_sous_type_prestataire, 'couleur':PrestataireJSON.result[i].couleur}).click(onMarkerClick);
}
 }		
}	


	
			
}

function onMarkerClick() {
	

      var marker = this;
	  var id = marker.id_alone;
      var latLng = marker.getPosition();
	  var content= marker.content;
	  var sous_type= marker.sous_type;
	var couleur = marker.couleur;
	var URL = marker.URL;
var map2 = $('#map_canvas').gmap('get', 'map');	

	if(sous_type==null){
	sous_type = '';	
	}
	  var infowindow = new InfoBubble({
	  id:id,
      map: map2,
      content: '<div style="cursor:pointer;" id="infobulle" class="infobulle_prestataire"><div class="rubrique_type_prestataire" style="color:#'+couleur+';">'+sous_type+'</div><div class="titre_big_infobulle">'+content+'</div><span id="detaillink"  style="color:#'+couleur+'; float:right; font-size:0.6em;" rel="'+id+'">Plus de détails [+]</span></div>',
      position :  latLng,
      shadowStyle: 1,
            padding: '10px',
            borderRadius: 5,
            minWidth: 130,
			minHeight:70,
			maxWidth:140,
            arrowSize: 15,
            borderWidth: 1,
            borderColor: '#2c2c2c',
            disableAutoPan: true,
            hideCloseButton: true,
            backgroundClassName: 'phoney'
        });
	
	if (openedInfoWindow != null) openedInfoWindow.close();
	infowindow.open(map2, marker);
	openedInfoWindow = infowindow;
	google.maps.event.addDomListener(infowindow.bubble_, 'click', function(){ClickDetailPrestataire(id)});	
$("#map_canvas").gmap("option", "center", latLng);
$('#map_canvas').gmap('option', 'zoom', 15);


    }

function getParamValue(param,url)
{
	var u = url == undefined ? document.location.href : url;
	var reg = new RegExp('(\\?|&|^)'+param+'=(.*?)(&|$)');
	var matches = u.match(reg);
	return (matches && matches[2] != undefined) ? decodeURIComponent(matches[2]).replace(/\+/g,' ') : '';
}	


function ClickDetailPrestataire(id){
	var idPrestataire = id;

	
		$.ajax({
		url:'http://www.lepuyconques.com/mobile/get_content.php?action=GetDetailPrestataire&id_prestataire='+idPrestataire, 
		dataType:'json', 
		success: getDetailPrestataire,
		error: onAjaxError
		});
}

function ClickDetailPrestataire2(event){
	event.preventDefault();
	
var idPrestataire = $(this).attr('rel');
ClickDetailPrestataire(idPrestataire);
}

function getDetailPrestataire(data){
		$('#detail_prestataire').page();
		DetailPrestataireJSON2=data;
		console.log(data);
var html = '<div style="width:100%; margin-bottom:10px;" class="theme_'+DetailPrestataireJSON2.result[0].theme+'"><div style="width:10%; float:left;">';

if(DetailPrestataireJSON2.result[0].IdPrestatairePrecedent){
html += '<a href="#" rel="'+DetailPrestataireJSON2.result[0].IdPrestatairePrecedent+'" data-role="button" data-icon="arrow-l" data-shadow="false"  id="prestataire_precedent" data-iconpos="notext">'+DetailPrestataireJSON2.result[0].IntituleSousTypePrestataire+' précédents</a>';
}

html += '</div><div style="width:10%; float:left;"><img src="images/'+DetailPrestataireJSON2.result[0].picto_princ+'"></div><div style="width:60%; float:left; text-align:center;">'+DetailPrestataireJSON2.result[0].nom+'</div><div style="width:10%; float:right;">';

if(DetailPrestataireJSON2.result[0].IdPrestataireSuivant){
html += '<a href="#" rel="'+DetailPrestataireJSON2.result[0].IdPrestataireSuivant+'" data-role="button" data-icon="arrow-r" data-shadow="false"  id="prestataire_suivant" data-iconpos="notext" style="float:right;">'+DetailPrestataireJSON2.result[0].IntituleSousTypePrestataire+' suivants</a>';
}

html += '</div></div>';

if(DetailPrestataireJSON2.result[0].Photo1){
	html += '<a href="#popupPhotoLandscape'+DetailPrestataireJSON2.result[0].id_prestataire+'" data-rel="popup" data-position-to="window" data-role="button" data-inline="true" style="float:left; max-width:40%;"><img src="'+DetailPrestataireJSON2.result[0].Photo1+'" style="max-width:100%;"></a>';
	
	html += '<div data-role="popup" id="popupPhotoLandscape'+DetailPrestataireJSON2.result[0].id_prestataire+'" data-overlay-theme="a" data-theme="d" data-corners="false"><a href="#" data-rel="back" data-role="button" data-theme="a" data-icon="delete" data-iconpos="notext" class="ui-btn-right">Fermer</a><img src="'+DetailPrestataireJSON2.result[0].Photo1+'" style="max-width:100%;"></div>';
}
html += '<div id="content_infos_prestataire"><strong>'+DetailPrestataireJSON2.result[0].nom+'</strong><br>'+DetailPrestataireJSON2.result[0].adresse1+'<br>';
if(DetailPrestataireJSON2.result[0].adresse2){
html += DetailPrestataireJSON2.result[0].adresse2+'<br>';	
}
if(DetailPrestataireJSON2.result[0].adresse3){
html += DetailPrestataireJSON2.result[0].adresse3+'<br>';	
}
html += DetailPrestataireJSON2.result[0].cp+' '+DetailPrestataireJSON2.result[0].commune+'<br>';
if(DetailPrestataireJSON2.result[0].tel){
html += 'Tél. <a href="tel:'+DetailPrestataireJSON2.result[0].tel+'">'+DetailPrestataireJSON2.result[0].tel+'</a><br>';	
}
if(DetailPrestataireJSON2.result[0].fax){
html += 'Fax : '+DetailPrestataireJSON2.result[0].fax+'<br>';	
}
if(DetailPrestataireJSON2.result[0].email){
html += '<a href="mailto:'+DetailPrestataireJSON2.result[0].email+'">'+DetailPrestataireJSON2.result[0].email+'</a><br>';	
}
if(DetailPrestataireJSON2.result[0].site_internet ){
html += '<a href="http://'+DetailPrestataireJSON2.result[0].site_internet +'" rel="external" target="_blank">'+DetailPrestataireJSON2.result[0].site_internet +'</a><br>';	
}
html += '</div>';
html += '<div data-role="navbar" id="navbar_internet">'
	+	'<ul>'
	+	'<li><a href="#" rel="divpresentation" class="ui-btn-active ui-state-persist theme_'+DetailPrestataireJSON2.result[0].theme+'">Présentation</a></li>'
	+	'<li><a href="#" rel="divmedias" class="theme_'+DetailPrestataireJSON2.result[0].theme+'">Médias</a></li>'
	+	'<li><a href="'+DetailPrestataireJSON2.result[0].id_prestataire+'" rel="map" class="theme_'+DetailPrestataireJSON2.result[0].theme+'">Y aller !</a></li>'
	+	'</ul>'
+	'</div>';

html += '<div id="content_prestataire">';
html += '<div id="divpresentation" class="content_prestataire_interne">';
if(DetailPrestataireJSON2.result[0].TextePresentation){
	html += '<p id="presentation">'+DetailPrestataireJSON2.result[0].TextePresentation+'</p><br><br>';
}

if(DetailPrestataireJSON2.result[0].TexteHoraires){
	html += '<h2 style="color:#'+DetailPrestataireJSON2.result[0].couleur+';">Horaires d\'ouverture</h2>';
	html += '<p>'+DetailPrestataireJSON2.result[0].TexteHoraires+'</p>';
}
html += '</div>';
html += '<div id="divmedias" style="display:none;" class="content_prestataire_interne"><br><br><br>';
	for(var j=1 ; j<DetailPrestataireJSON2.result.length; j++){
		var url_file = '';
		if(DetailPrestataireJSON2.result[j].is_media_embarque_mobile==1){
			url_file = 'fichiers/';
		}else{
			url_file = 'http://www.lepuyconques.com/mobile/fichiers/';
		}
	html += '<a href="'+url_file+DetailPrestataireJSON2.result[j].fichier+'" target="_blank" style="height:37px; color:#000; font-size:12px;"><img src="images/pictos/'+DetailPrestataireJSON2.result[j].picto+'" style="margin-right:10px; float:left;">'+DetailPrestataireJSON2.result[j].PresentationMedia;
	if(DetailPrestataireJSON2.result[j].is_media_handicap==1){
	html += '<img src="images/pictos/picto_media_handicap.png" alt="Média adapté HANDICAP VISUEL" title="Média adapté HANDICAP VISUEL" style="margin-left:10px; float:right;">';
	}
	html += '</a><br><br><hr>';	
		
}
html += '</div>';

html += '</div>';






			
		$('#detail_prestataire div[data-role=content]').html(html).trigger('create');
		$.mobile.changePage('#detail_prestataire', {transition:'slide'});
$('#prestataire_precedent').click(ClickDetailPrestataire2);	
$('#prestataire_suivant').click(ClickDetailPrestataire2);	
$('#navbar_internet a').click(ClickNavBarre);			
}

function ClickNavBarre(event){
	event.preventDefault();
	var type = $(this).attr('rel');
	if(type=='map'){
	ClickReturnMap($(this).attr('href'));	
	}
$('#detail_prestataire div[data-role=content] #content_prestataire .content_prestataire_interne').css({'display' : 'none'});	
$('#detail_prestataire div[data-role=content] #content_prestataire #'+type).css({'display' : 'block'});	
}
	
	
function ClickReturnMap(id_prestataire){
if (openedInfoWindow != null)openedInfoWindow.close();
$('#map_canvas').gmap('find', 'markers', { }, function(marker) {
	
if(marker.id_alone == id_prestataire){
	
	marker.setVisible(true);
	var PointMarker = new google.maps.LatLng(marker.position.hb,marker.position.ib);	
	$('#map_canvas').gmap({ 'center' : PointMarker});
	$('#map_canvas').gmap('option', 'zoom', 17); 
	
}else if((marker.id=='point_depart')||(marker.id=='point_arrivee')||(marker.id=='user')){
marker.setVisible(true);
 }else{
marker.setVisible(false); 
 }
}); 


$("#interactivmap #control" ).popup( "close" );	

 $.mobile.changePage('#interactivmap', {transition:'slide'});
}

function onAjaxError(jqXHR, textStatus, errorThrown){
	
	console.log(jqXHR);
	//alert(textStatus + ' : '+ errorThrown);
	
}
	
})(jQuery);